

# CreateUserSettings
<a name="API_CreateUserSettings"></a>

Creates a user settings resource that can be associated with a web portal. Once associated with a web portal, user settings control how users can transfer data between a streaming session and the their local devices. 

## Request Syntax
<a name="API_CreateUserSettings_RequestSyntax"></a>

```
POST /userSettings HTTP/1.1
Content-type: application/json

{
   "additionalEncryptionContext": { 
      "string" : "string" 
   },
   "brandingConfigurationInput": { 
      "colorTheme": "string",
      "favicon": { ... },
      "localizedStrings": { 
         "string" : { 
            "browserTabTitle": "string",
            "contactButtonText": "string",
            "contactLink": "string",
            "loadingText": "string",
            "loginButtonText": "string",
            "loginDescription": "string",
            "loginTitle": "string",
            "welcomeText": "string"
         }
      },
      "logo": { ... },
      "termsOfService": "string",
      "wallpaper": { ... }
   },
   "clientToken": "string",
   "cookieSynchronizationConfiguration": { 
      "allowlist": [ 
         { 
            "domain": "string",
            "name": "string",
            "path": "string"
         }
      ],
      "blocklist": [ 
         { 
            "domain": "string",
            "name": "string",
            "path": "string"
         }
      ]
   },
   "copyAllowed": "string",
   "customerManagedKey": "string",
   "deepLinkAllowed": "string",
   "disconnectTimeoutInMinutes": number,
   "downloadAllowed": "string",
   "idleDisconnectTimeoutInMinutes": number,
   "pasteAllowed": "string",
   "printAllowed": "string",
   "tags": [ 
      { 
         "Key": "string",
         "Value": "string"
      }
   ],
   "toolbarConfiguration": { 
      "hiddenToolbarItems": [ "string" ],
      "maxDisplayResolution": "string",
      "toolbarType": "string",
      "visualMode": "string"
   },
   "uploadAllowed": "string",
   "webAuthnAllowed": "string"
}
```

## URI Request Parameters
<a name="API_CreateUserSettings_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateUserSettings_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [additionalEncryptionContext](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-additionalEncryptionContext"></a>
The additional encryption context of the user settings.  
Type: String to string map  
Key Length Constraints: Minimum length of 0. Maximum length of 131072.  
Key Pattern: `[\s\S]*`   
Value Length Constraints: Minimum length of 0. Maximum length of 131072.  
Value Pattern: `[\s\S]*`   
Required: No

 ** [brandingConfigurationInput](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-brandingConfigurationInput"></a>
The branding configuration input that customizes the appearance of the web portal for end users. This includes a custom logo, favicon, localized strings, color theme, and optionally a wallpaper and terms of service.  
Type: [BrandingConfigurationCreateInput](API_BrandingConfigurationCreateInput.md) object  
Required: No

 ** [clientToken](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-clientToken"></a>
A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.   
If you do not specify a client token, one is automatically generated by the AWS SDK.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 512.  
Required: No

 ** [cookieSynchronizationConfiguration](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-cookieSynchronizationConfiguration"></a>
The configuration that specifies which cookies should be synchronized from the end user's local browser to the remote browser.  
Type: [CookieSynchronizationConfiguration](API_CookieSynchronizationConfiguration.md) object  
Required: No

 ** [copyAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-copyAllowed"></a>
Specifies whether the user can copy text from the streaming session to the local device.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: Yes

 ** [customerManagedKey](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-customerManagedKey"></a>
The customer managed key used to encrypt sensitive information in the user settings.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:[\w+=\/,.@-]+:kms:[a-zA-Z0-9\-]*:[a-zA-Z0-9]{1,12}:key\/[a-zA-Z0-9-]+`   
Required: No

 ** [deepLinkAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-deepLinkAllowed"></a>
Specifies whether the user can use deep links that open automatically when connecting to a session.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: No

 ** [disconnectTimeoutInMinutes](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-disconnectTimeoutInMinutes"></a>
The amount of time that a streaming session remains active after users disconnect.  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 600.  
Required: No

 ** [downloadAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-downloadAllowed"></a>
Specifies whether the user can download files from the streaming session to the local device.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: Yes

 ** [idleDisconnectTimeoutInMinutes](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-idleDisconnectTimeoutInMinutes"></a>
The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the disconnect timeout interval begins.  
Type: Integer  
Valid Range: Minimum value of 0. Maximum value of 60.  
Required: No

 ** [pasteAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-pasteAllowed"></a>
Specifies whether the user can paste text from the local device to the streaming session.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: Yes

 ** [printAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-printAllowed"></a>
Specifies whether the user can print to the local device.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: Yes

 ** [tags](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-tags"></a>
The tags to add to the user settings resource. A tag is a key-value pair.  
Type: Array of [Tag](API_Tag.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 200 items.  
Required: No

 ** [toolbarConfiguration](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-toolbarConfiguration"></a>
The configuration of the toolbar. This allows administrators to select the toolbar type and visual mode, set maximum display resolution for sessions, and choose which items are visible to end users during their sessions. If administrators do not modify these settings, end users retain control over their toolbar preferences.  
Type: [ToolbarConfiguration](API_ToolbarConfiguration.md) object  
Required: No

 ** [uploadAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-uploadAllowed"></a>
Specifies whether the user can upload files from the local device to the streaming session.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: Yes

 ** [webAuthnAllowed](#API_CreateUserSettings_RequestSyntax) **   <a name="workspacesweb-CreateUserSettings-request-webAuthnAllowed"></a>
Specifies whether the user can use WebAuthn redirection for passwordless login to websites within the streaming session.  
Type: String  
Valid Values: `Disabled | Enabled`   
Required: No

## Response Syntax
<a name="API_CreateUserSettings_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "userSettingsArn": "string"
}
```

## Response Elements
<a name="API_CreateUserSettings_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [userSettingsArn](#API_CreateUserSettings_ResponseSyntax) **   <a name="workspacesweb-CreateUserSettings-response-userSettingsArn"></a>
The ARN of the user settings.  
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:[\w+=\/,.@-]+:[a-zA-Z0-9\-]+:[a-zA-Z0-9\-]*:[a-zA-Z0-9]{1,12}:[a-zA-Z]+(\/[a-fA-F0-9\-]{36})+` 

## Errors
<a name="API_CreateUserSettings_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Access is denied.  
HTTP Status Code: 403

 ** ConflictException **   
There is a conflict.    
 ** resourceId **   
Identifier of the resource affected.  
 ** resourceType **   
Type of the resource affected.
HTTP Status Code: 409

 ** InternalServerException **   
There is an internal server error.    
 ** retryAfterSeconds **   
Advice to clients on when the call can be safely retried.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The resource cannot be found.    
 ** resourceId **   
Hypothetical identifier of the resource affected.  
 ** resourceType **   
Hypothetical type of the resource affected.
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The service quota has been exceeded.    
 ** quotaCode **   
The originating quota.  
 ** resourceId **   
Identifier of the resource affected.  
 ** resourceType **   
 Type of the resource affected.  
 ** serviceCode **   
The originating service.
HTTP Status Code: 402

 ** ThrottlingException **   
There is a throttling error.    
 ** quotaCode **   
The originating quota.  
 ** retryAfterSeconds **   
Advice to clients on when the call can be safely retried.  
 ** serviceCode **   
The originating service.
HTTP Status Code: 429

 ** ValidationException **   
There is a validation error.    
 ** fieldList **   
The field that caused the error.  
 ** reason **   
Reason the request failed validation
HTTP Status Code: 400

## See Also
<a name="API_CreateUserSettings_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/workspaces-web-2020-07-08/CreateUserSettings) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/workspaces-web-2020-07-08/CreateUserSettings) 